
import data
import pygame, os
from pygame.locals import *
from player import Player
from Mutant import Mutant

def main():

    SCREEN_WIDTH = 640
    SCREEN_HEIGHT = 480
    FPS = 60
    
    GREEN_MUTANT = 1
    YELLOW_MUTANT = 2
        
    pygame.init()
    screen = pygame.display.set_mode([SCREEN_WIDTH, SCREEN_HEIGHT])
    screen.fill((0,0,0))
    pygame.display.flip()

    clock = pygame.time.Clock()

    hero = Player(SCREEN_WIDTH, SCREEN_HEIGHT, 100, 100, "", "")

    baddies = []
    baddies.append(Mutant(SCREEN_WIDTH, SCREEN_HEIGHT, 300, 300, "", ""))
    baddies.append(Mutant(SCREEN_WIDTH, SCREEN_HEIGHT, 50, 200, "", ""))
    baddies.append(Mutant(SCREEN_WIDTH, SCREEN_HEIGHT, 150, 300, "", ""))
    baddies.append(Mutant(SCREEN_WIDTH, SCREEN_HEIGHT, 200, 50, "", ""))
    
    main_loop = True

    while main_loop:

        screen.fill((0, 0, 0))

        for event in pygame.event.get():
            if event.type == pygame.QUIT: 
                main_loop = False
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    main_loop = False

        hero.update()
        screen.blit(hero.image, hero.rect)
        
        for baddie in baddies:
            baddie.update()
            
            # Collision test
            if (hero.rect.colliderect(baddie.rect.left, baddie.rect.top, 32, 32)
                    and baddie.collided_with_player == False):
                baddie.dx = hero.dx
                baddie.dy = hero.dy
                baddie.collided_with_player = True
                hero.dx = -hero.dx
                hero.dy = -hero.dy
                
            # Reset baddie collision field?
            if (not(hero.rect.colliderect(baddie.rect.left, baddie.rect.top, 32, 32))):
                baddie.collided_with_player = False

            screen.blit(baddie.image, baddie.rect)
            
        pygame.display.flip()
        clock.tick(FPS)

    pygame.quit()
