import pygame, os
from pygame.locals import *

class Player(pygame.sprite.Sprite):

    def __init__(self, screen_width, screen_height, sx, sy, data_folder, image_file):
        pygame.sprite.Sprite.__init__(self)
        self.screen_width = screen_width
        self.screen_height = screen_height
        
        self.x = sx
        self.y = sy
        self.dx = 0
        self.dy = 0
        self.image = pygame.Surface((32, 32))
        self.image.fill((0, 0, 255))
        self.rect = self.image.get_rect(topleft = (sx, sy))
        self.max_vector_speed = 7
        self.deccel = 0.3
        self.accel = 0.7
        
    def update(self):
        keys = pygame.key.get_pressed()

        if keys[K_LEFT]:
            self.dx -= self.accel
            
        if keys[K_RIGHT]:
            self.dx += self.accel

        if keys[K_UP]:
            self.dy -= self.accel
                    
        if keys[K_DOWN]:
            self.dy += self.accel
            
        # Slow down if a key is not pressed down, but player is travelling in that direction
        if (not(keys[K_LEFT]) and not(keys[K_RIGHT])):
            if (self.dx < 0):
                self.dx += self.deccel
            elif(self.dx > 0):
                self.dx -= self.deccel

        if (not(keys[K_UP]) and not(keys[K_DOWN])):
            if (self.dy < 0):
                self.dy += self.deccel
            elif(self.dy > 0):
                self.dy -= self.deccel

        # Keep the vector speed within its limits
        if (self.dx < -self.max_vector_speed):
            self.dx = -self.max_vector_speed

        if (self.dx > self.max_vector_speed):
            self.dx = self.max_vector_speed
                
        if (self.dy < -self.max_vector_speed):
            self.dy = -self.max_vector_speed

        if (self.dy > self.max_vector_speed):
            self.dy = self.max_vector_speed

        # Make the movement calculation
        self.rect.move_ip(self.dx, self.dy)

        SCREEN_LIMIT = Rect(-28, -28, self.screen_width+56, self.screen_height +56)
        self.rect.clamp_ip(SCREEN_LIMIT)
